### prioritaetswarteschlange-iterativ.py
### Stellt die zur Verwaltung einer Prioritaetswarteschlange
### notwendigen Funktionen bereit.
### Benoetigt ein Vergleichspraedikat vor , das hier
### beispielhaft mit verschiedenen Varianten realisiert ist.

### ===== fuege_eines_ein =====
# fuegt ein Element in die Prio-Schlange ein
# benötigt das Praedikat vor
def fuege_eines_ein(eines, vor, priows):
    for i in range(len(priows)):
        if vor(eines, priows[i]):
            return priows[:i] + [eines] + priows[i:]
    return priows + [eines]

### ===== fuege_alle_ein =====
# fuegt alle uebergebenen Elemente in die Prio-Schlange ein
def fuege_alle_ein(alle, vor , priows):
    for eines in alle:
        priows=fuege_eines_ein(eines, vor, priows)
    return priows

# Tests:
### ===== vor =====
# -> Einfach Zahlen
##def vor(zahl_1, zahl_2): return zahl_1 < zahl_2
##print(fuege_eines_ein(10, vor, [1, 11, 21])) # -> [1, 10, 11, 21]
##print(fuege_eines_ein(33, vor, [1, 11, 21])) # -> [1, 11, 21, 33]
##print(fuege_alle_ein([33, 0, 10], vor , [1, 11, 21])) # -> [0, 1, 10, 11, 21, 33]
##print(fuege_alle_ein([7, -2, 33, 100, 10, 9], vor , [])) # -> [-2, 7, 9, 10, 33, 100]

### -> Strings
##def vor(string_1, string_2): return string_1 < string_2
##print(fuege_eines_ein("hund", vor, ["aal", "katze", "ziege"]))
##print(fuege_alle_ein (["hund", "ziege", "aal"], vor, ["amsel", "katze", "tiger"]))

### -> Wege in Graphen mit der Aktuellen Laenge am Kopf
def vor(weg_1, weg_2): return weg_1[0] < weg_2[0]
##print(fuege_eines_ein([43, 'M', 'I'], vor, [[34, 'B', 'I'], [40, 'C', 'I'], [65, 'H', 'I']]))
##print(fuege_alle_ein ([[60, 'X', 'B', 'I'], [103, 'A', 'B', 'I'], [64, 'H', 'B', 'I']], vor , [[40, 'C', 'I'], [43, 'M', 'I'], [55, 'P', 'I'], [65, 'H', 'I']]))

### -> Kanten in Graphen mit der Laenge an dritter Position
##def vor(kante_1, kante_2): return kante_1[0] < kante_2[0]
##print(fuege_eines_ein([60, 'G', 'E'], vor, [[30, 'B', 'H'], [69, 'A', 'B']]))
##print(fuege_alle_ein ([[69, 'A', 'B'], [36, 'A', 'D'], [22, 'A', 'N'], [36, 'A', 'M']], vor , []))
